import { world } from '@minecraft/server';
import { ActionFormData, ActionFormResponse, ModalFormResponse, ModalFormData } from '@minecraft/server-ui';




world.afterEvents.itemUse.subscribe((data) => {

    const player = data.source;
    const item = data.itemStack;

    const menu = new ActionFormData()
        .title("Viral Coral : Menu")
        .button("Command")
        .button("Quick Commands")
        .button("effects")
        .button("Pranks")
        .button("Chat Message")
        .button("Items");

    const effectmenu = new ActionFormData()
        .title("Effect Menu.")
        .button("IMMORTALITY")
        .button("SPEED")
        .button("STRENGTH")
        .button("HASTE")
        .button("NIGHT VISION")
        .button("CLEAR")
        .button("SATURATION");

    const Commandmenu = new ModalFormData()
        .title("VC- Command")
        .textField("", "", "");

    const quickcommandsmenu = new ActionFormData()
        .title("Quick Commands~")
        .button("Creative")
        .button("survival")
        .button("Day")
        .button("Night")
        .button("32k kit");

    const chatmessage = new ModalFormData()
        .title("Chat Message")
        .textField("Message", "", "");

    const itemmenu = new ActionFormData()
        .title("Items")
        .button("Wand")

    const prankmenu = new ActionFormData()
        .title("Prank Menu")
        .button("explode all")
        .button("summon 10 withers")
        .button("Start Time loop")
        .button("Stop Time loop")
        .button("Start Inventory crush")
        .button("UWU")
        .button("no UwU")
        .button("Start Toon World")
        .button("Stop Toon World");

    if (item.typeId === "minecraft:ghast_tear") {
        menu.show(player).then((Response) => {

            //---------------EFFECT MENU
            if (Response.selection == 2) {
                effectmenu.show(player).then((response) => {
                    if (response.canceled) { menu.show(player) }
                    if (response.selection == 0) { player.runCommandAsync("effect @s resistance 99999 255 true") }
                    if (response.selection == 1) { player.runCommandAsync("effect @s speed 99999 7 true") }
                    if (response.selection == 2) { player.runCommandAsync("effect @s strength 99999 255 true") }
                    if (response.selection == 3) { player.runCommandAsync("effect @s haste 99999 255 true") }
                    if (response.selection == 4) { player.runCommandAsync("effect @s night_vision 99999 255 true") }
                    if (response.selection == 5) { player.runCommandAsync("effect @s clear") }
                    if (response.selection == 6) { player.runCommandAsync("effect @s saturation 99999 255 true") }

                })
            }
            //-------------------COMMAND 
            if (Response.selection == 0) {
                if (Response.canceled) { menu.show(player) }
                if (Response.selection == 0) {
                    Commandmenu.show(player).then((Response) => {
                        const vcc = Response.formValues;
                        player.runCommandAsync(`${vcc}`)
                        player.sendMessage(`§5[VC-Command run  "${vcc}" ]`)
                    })
                }

            }
            //--------------QUICK COMMAND
            if (Response.selection == 1) {
                quickcommandsmenu.show(player).then((Response) => {
                    if (Response.selection == 0) { player.runCommandAsync("gamemode c"), (player.sendMessage("§5[VC-Gamemode Changed to creative]")) }
                    if (Response.selection == 1) { player.runCommandAsync("gamemode s"), (player.sendMessage("§5[VC-Gamemode Changed to Survival]")) }
                    if (Response.selection == 2) { player.runCommandAsync("time set day"), (player.sendMessage("§5[VC-Time set to day]")) }
                    if (Response.selection == 3) { player.runCommandAsync("time set midnight"), (player.sendMessage("§5[VC-Time set to midnight]")) }
                    if (Response.selection == 4) { player.runCommandAsync("structure load vc_k ~ ~ ~"), (player.sendMessage("§5[VC-32k kit Given]")) }

                })
                //---------------CHAT MESSAGE
            }
            if (Response.selection == 4) {
                chatmessage.show(player).then((Response) => {
                    const msg = Response.formValues;
                    player.runCommandAsync(`/tellraw @a {"rawtext":[{"text":"${msg}"}]}`)
                })
            }
            //---------------ITEMS MENU
            if (Response.selection == 5) {
                itemmenu.show(player).then((Response) => {
                    if (Response.selection == 0) { player.runCommandAsync("structure load vc_wa ~~~") }

                })
            }

            if (Response.selection == 3) {
                prankmenu.show(player).then((Response) => {
                    if (Response.selection == 0) { player.runCommandAsync("execute at @e[rm=2] run /summon tnt"), (player.sendMessage("§5[VC-Tnt summoned]")) }
                    if (Response.selection == 1) { player.runCommandAsync("summon wither"), player.runCommandAsync("summon wither"), player.runCommandAsync("summon wither"), player.runCommandAsync("summon wither"), player.runCommandAsync("summon wither"), player.runCommandAsync("summon wither"), player.runCommandAsync("summon wither"), player.runCommandAsync("summon wither"), player.runCommandAsync("summon wither"), player.runCommandAsync("summon wither"), (player.sendMessage("§5[VC-wither storm!]")) }
                    if (Response.selection == 2) { player.runCommandAsync("tag @s add force_time_loop"), (player.sendMessage("§5[VC-Enabled Time loop]")) }
                    if (Response.selection == 3) { player.runCommandAsync("tag @s remove force_time_loop"), (player.sendMessage("§5[VC-Disabled Time loop]")) }
                    if (Response.selection == 4) { player.runCommandAsync("tag @s add force_inventory_crush"), (player.sendMessage("§5[VC-Crushed inventorys]")) }
                    if (Response.selection == 5) { player.runCommandAsync("tag @s add uwu_spam"), (player.sendMessage("§5[VC-UwU Daddy~]")) }
                    if (Response.selection == 6) { player.runCommandAsync("tag @s remove uwu_spam"), (player.sendMessage("§5[VC-UwU sorry]")) }
                    if (Response.selection == 7) { player.runCommandAsync("tag @s add force_toonworld"), (player.sendMessage("§5[VC-TOON WORLD!!]")) }
                    if (Response.selection == 8) { player.runCommandAsync("tag @s remove force_toonworld"), (player.sendMessage("§5[VC-aww.. no toon world]")) }
                })
            }

        })
    }
});

world.afterEvents.projectileHitEntity.subscribe((data) => {
    const hit = data.source

    hit.runCommandAsync("tag @s add quickhitcheck")
    hit.runCommandAsync("/playsound note.bell @s ~ ~ ~ 20 1.5")
    hit.runCommandAsync("scoreboard players add @s bowhitcount 25")
    hit.runCommandAsync("scoreboard players add @s bowhit 1")

})